# Self Organizing Maps (DL\_SOM)

Self-organizing maps (SOM), also known as Kohonen maps, are a type of artificial neural network that can be used for unsupervised learning and data visualization. They are typically used for clustering and dimensionality reduction of complex data sets.

SOMs consist of a two-dimensional grid of nodes or neurons, each of which represents a different feature or attribute of the data. During training, the SOM learns to associate similar data points with adjacent neurons on the grid. This results in a topology-preserving mapping of the input space onto the two-dimensional grid.

SOMs are often used in data visualization applications because they can represent high-dimensional data in a two-dimensional map, making it easier to understand and interpret. They have been used in a variety of fields, including image and speech recognition, text mining, and pattern recognition.

## Sample Request

Build an SOM for data clustering

```json
{
    "project_id": 1,
    "parent_id": 7,
    "block_id": 8,
    "function_code": "DL_SOM_I",
    "args": {
    "hyp_params":{
            "x": 10,
            "y": 10,
            "input_len": 14,
            "sigma": 1.0,
            "learning_rate": 0.1,
        }
    }
}
```

## Building a Self Organizing Map

## SOM Construction

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                                                            |
| ------------------------------------------------ | ------ | -------------------------------------------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | The `id` of the current project                                                        |
| block\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the current block                                                          |
| function\_code<mark style="color:red;">\*</mark> | string | The function code for current block                                                    |
| parent\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the previous block                                                         |
| args<mark style="color:red;">\*</mark>           | object | Block arguments                                                                        |
| x<mark style="color:red;">\*</mark>              | int    | x dimension                                                                            |
| y<mark style="color:red;">\*</mark>              | int    | y dimension                                                                            |
| input\_len<mark style="color:red;">\*</mark>     | int    | Number of the elements of the vectors in input                                         |
| learning\_rate                                   | float  | initial learning rate                                                                  |
| sigma                                            | float  | Spread of the neighborhood function, needs to be adequate to the dimensions of the map |

{% tabs %}
{% tab title="200 Statemanagement object" %}

```json
{
    "status": "true",
    "message": {
        "id": 8,
        "project": 1,
        "block_id": 8,
        "parent_id": 7,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": {}
    }
}
```

{% endtab %}
{% endtabs %}

## Sample Request

Compile and train the pre-built SOM model, using passed in Hyper Parameters

```json
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "DL_SOM_T",
    "args": {
        "model_name": "titanic_model",
        "hyp_params":{
            "num_iterations": 100
        }
    }
}
```

## Training a Sequential Organizing Map

## SOM Training

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1`

#### Request Body

| Name                                              | Type   | Description                                         |
| ------------------------------------------------- | ------ | --------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the current project                     |
| hyp\_params<mark style="color:red;">\*</mark>     | object | hyper parameters for model compilation and training |
| parent\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the previous block                      |
| block\_id<mark style="color:red;">\*</mark>       | int    | The `id` of the current block                       |
| function\_code<mark style="color:red;">\*</mark>  |        | The function code for current block                 |
| args<mark style="color:red;">\*</mark>            | object | Block arguments                                     |
| model\_name<mark style="color:red;">\*</mark>     | String | The name the model would be saved with              |
| num\_iterations<mark style="color:red;">\*</mark> | int    | number of training iterations                       |

{% tabs %}
{% tab title="200: OK Statemanagement Object" %}

```json
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": {}
    }
}
```

{% endtab %}
{% endtabs %}

## Sample Request

Make predictions with the trained SOM model.

```json
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "DL_SOM_P",
    "args": {
        "test_data": "",
        "row": 12,
    }
}
```

## Predicting Cluster with an Self Organizing Map

## SOM Predict

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                         |
| ------------------------------------------------ | ------ | ----------------------------------- |
| test\_data<mark style="color:red;">\*</mark>     | String | Input data for prediction           |
| project\_id<mark style="color:red;">\*</mark>    | int    | ID of the current project           |
| block\_id<mark style="color:red;">\*</mark>      | int    | ID of the current block             |
| parent\_id<mark style="color:red;">\*</mark>     | int    | ID of the previous block            |
| function\_code<mark style="color:red;">\*</mark> | String | Function code for the current block |
| args<mark style="color:red;">\*</mark>           | object | Block arguments                     |
| row                                              | int    | row in the dataset to be used       |

{% tabs %}
{% tab title="200: OK Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": {}
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```
// Some code
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.autogon.ai/autogon-engine-studio/deep-learning/self-organizing-maps-dl_som.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
